library array_playground;

extension AsyncRemoveWhere on List{
  Future<void> asyncRemoveWhere(Future<bool> test(dynamic a))async{
    //Keep track of how many  items have been removed
    int itemsRemoved = 0;
    //Check each item on the list
    for(int i = 0; i < this.length;  i++){
      //The item position that will be affected depending on the amount of items removed
      int itemPosition = i - itemsRemoved;
      if(await test(this[itemPosition])){
        //Remove the item at the specified index
        this.removeAt(itemPosition);
        //Add 1 to the amount of items removed
        itemsRemoved++;
      }
    }
  }
}